//---------------------------------------------------------------------------
// (c)Alex A. Trubetskoy            alextr438@yandex.ru
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Main.h"
#include "About.h"
#include "NewName.h"
#include "FormOptionsUnit.h"
#include "FormConfirmUnit.h"
#include "FormPropUnit.h"
#include "FormOvrwrtUnit.h"
#include "FormProgressUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cdiroutl"
#pragma link "ListViewFiles"
#pragma resource "*.dfm"
TmainForm *mainForm;
//---------------------------------------------------------------------------
__fastcall TmainForm::TmainForm(TComponent* Owner)
        : TForm(Owner)
{
    leftAsTree = false;
    rightAsTree = false;
    clrForm = clSilver;
    clrBkg = clWindow;
    mr = 0;
    confFileName = GetCurrentDir() + "\\config.cfg";
    pathEditor = pathLeft = pathRight = "";
    pSelFilesPath = new TStringList();
    pSelFilesName = new TStringList();

    int hFile, fileLen, i = 0;
    AnsiString color;
    char* buf;
    if(!FileExists(confFileName)) {
        pathEditor = "C:\\Windows\\notepad.exe ";
        chkCopy = chkMove = chkDelDir = chkDel = true;
    }
    else {     //retrieve options from the configuration file
        if((hFile = FileOpen(confFileName, fmOpenRead)) == -1) {
            MessageBox(NULL, "Unable to open the configuration file  ",
                 "Error", MB_ICONSTOP);
            return;
        }
        fileLen = FileSeek(hFile, 0, 2);
        FileSeek(hFile, 0, 0);
        buf = new char[fileLen + 1];
        FileRead(hFile, buf, fileLen);
        FileClose(hFile);
        for(; i < fileLen && buf[i] != '\n'; ++i) {
            pathEditor += buf[i];
        }
        pathEditor = pathEditor.TrimRight();
        pathEditor += ' ';
        while(i < fileLen && buf[i] == '\n') ++i;

        if(i < fileLen) {
            if(buf[i++] == 't') chkDelDir = true;
            else chkDelDir = false;
        }
        while(i < fileLen && buf[i] == '\n') ++i;
        if(i < fileLen) {
            if(buf[i++] == 't') chkDel = true;
            else chkDel = false;
        }
        while(i < fileLen && buf[i] == '\n') ++i;
        if(i < fileLen) {
            if(buf[i++] == 't') chkCopy = true;
            else chkCopy = false;
        }
        while(i < fileLen && buf[i] == '\n') ++i;
        if(i < fileLen) {
            if(buf[i++] == 't') chkMove = true;
            else chkMove = false;
        }

        while(i < fileLen && buf[i] == '\n') ++i;
        for(; i < fileLen && buf[i] != '\n'; ++i) {
            pathLeft += buf[i];
        }
        if(i < fileLen && buf[i] == '\n') ++i;
        for(; i < fileLen && buf[i] != '\n'; ++i) {
            pathRight += buf[i];
        }

        while(i < fileLen && buf[i] == '\n') ++i;
        if(i < fileLen) {
            if(buf[i++] == 's') sysClrForm = true;
            else sysClrForm = false;
        }
        while(i < fileLen && buf[i] == '\n') ++i;
        if(i < fileLen) {
            if(buf[i++] == 's') sysClrBkg = true;
            else sysClrBkg = false;
        }
        while(i < fileLen && buf[i] == '\n') ++i;
        for(; i < fileLen && buf[i] != '\n'; ++i) {
            color += buf[i];
        }
        if(color.Length() && !sysClrForm)
            clrForm = TColor(StrToInt(color));
        else
            clrForm = clBtnFace;
        color = "";
        while(i < fileLen && buf[i] == '\n') ++i;
        for(; i < fileLen && buf[i] != '\n'; ++i) {
            color += buf[i];
        }
        if(color.Length() && !sysClrBkg)
            clrBkg = TColor(StrToInt(color));
        else
            clrBkg = clWindow;

        delete[] buf;
    }
}
//---------------------------------------------------------------------------
__fastcall TmainForm::~TmainForm()
{
    if(pSelFilesPath)delete pSelFilesPath;
    if(pSelFilesName)delete pSelFilesName;
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::FormCreate(TObject *Sender)
{
    static char * Drive_Letter[]={"a:\\","b:\\","c:\\","d:\\","e:\\","f:\\",
        "g:\\","h:\\","i:\\","j:\\","k:\\","l:\\","m:\\","n:\\","o:\\","p:\\",
        "q:\\","r:\\","s:\\","t:\\","u:\\","v:\\","w:\\","x:\\","y:\\","z:\\"};
    int addedIndexL, addedIndexR;

    for(int x=0; x <= 25; ++x) {
        switch(GetDriveType(Drive_Letter[x])) {
            case DRIVE_REMOVABLE:
            case DRIVE_FIXED:
            case DRIVE_REMOTE:
            case DRIVE_CDROM:
            case DRIVE_RAMDISK:
                addedIndexL = tsLeft->Tabs->Add(Drive_Letter[x]);
                addedIndexR = tsRight->Tabs->Add(Drive_Letter[x]);
                break;
        }
        if (toupper(*Drive_Letter[x]) == lvfLeft->Drive)
            tsLeft->TabIndex = addedIndexL;
        if (toupper(*Drive_Letter[x]) == lvfRight->Drive)
            tsRight->TabIndex = addedIndexR;
    }
    if(pathLeft.Length()) {
        editPathLeft->Text = pathLeft;
        lvfLeft->Directory = pathLeft;
        lvfLeft->UpdateData();
    }
    if(pathRight.Length()) {
        editPathRight->Text = pathRight;
        lvfRight->Directory = pathRight;
        lvfRight->UpdateData();
    }
    makeLeftActive(true);
    setColor();
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::miViewTreeClick(TObject *Sender)
{
   if(!miViewTree->Checked) {
      miViewFiles->Checked = false;
      miViewTree->Checked = true;
      if(leftActive) {
         leftAsTree = true;
         lvfLeft->Visible = false;
         doLeft->Visible = true;
         doLeft->Directory = pathLeft;
         editPathLeft->Text = doLeft->Directory.LowerCase();
         lvfRight->Directory = doLeft->Directory;
      }
      else {
         rightAsTree = true;
         lvfRight->Visible = false;
         doRight->Visible = true;
         doRight->Directory = pathRight;
         editPathRight->Text = doRight->Directory.LowerCase();
         lvfLeft->Directory = doRight->Directory;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::miViewFilesClick(TObject *Sender)
{
   if(!miViewFiles->Checked) {
      miViewFiles->Checked = true;
      miViewTree->Checked = false;
      if(leftActive) {
         leftAsTree = false;
         lvfLeft->Visible = true;
         doLeft->Visible = false;
         editPathLeft->Text = lvfLeft->Directory.LowerCase();
         pathLeft = lvfLeft->Directory.LowerCase();
      }
      else {
         rightAsTree = false;
         lvfRight->Visible = true;
         doRight->Visible = false;
         editPathRight->Text = lvfRight->Directory.LowerCase();
         pathRight = lvfRight->Directory.LowerCase();
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::FormResize(TObject *Sender)
{
    lvfLeft->Width = Width/2 - 10;
    doLeft->Width = Width/2 - 10;
    tsLeft->Width = Width/2 - 10;
    editPathLeft->Width = Width/2 - 10;
    lvfRight->Left = Width/2;          lvfRight->Width = Width/2 - 15;
    doRight->Left = Width/2;           doRight->Width = Width/2 - 15;
    tsRight->Left = Width/2;           tsRight->Width = Width/2 - 15;
    editPathRight->Left = Width/2;     editPathRight->Width = Width/2 - 15;
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::tsLeftClick(TObject *Sender)
{
    char drive = *((tsLeft->Tabs->Strings[tsLeft->TabIndex]).c_str());
    if(!rightAsTree && (pathRight[1] == drive)) {
        doLeft->Directory = pathRight;
        lvfLeft->Directory = pathRight;
    }
    else {
        doLeft->Drive = drive;
        lvfLeft->Drive = drive;
    }
    pathLeft = lvfLeft->Directory;
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::tsRightClick(TObject *Sender)
{
    char drive = *((tsRight->Tabs->Strings[tsRight->TabIndex]).c_str());
    if(!leftAsTree && (pathLeft[1] == drive)) {
        doRight->Directory = pathLeft;
        lvfRight->Directory = pathLeft;
    }
    else {
        doRight->Drive = drive;
        lvfRight->Drive = drive;
    }
    pathRight = lvfRight->Directory;
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::makeLeftActive(bool left)
{
    if(left) {
        leftActive = true;
        if(leftAsTree) {miViewTree->Checked = true;  miViewFiles->Checked = false;}
        else {miViewTree->Checked = false; miViewFiles->Checked = true;}
        editPathLeft->Color = clActiveCaption;
        editPathRight->Color = clInactiveCaption;
    }
    else {
        leftActive = false;
        if(rightAsTree) {miViewTree->Checked = true;  miViewFiles->Checked = false;}
        else {miViewTree->Checked = false; miViewFiles->Checked = true;}
        editPathRight->Color = clActiveCaption;
        editPathLeft->Color = clInactiveCaption;
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::lvfDblClick(TObject *Sender)
{
    TListViewFiles* pLvf = (TListViewFiles*)Sender;
    if((pLvf->OnlyFileName.Pos("..") <= 3) &&
        (pLvf->OnlyFileName.Pos("..") > 0)) {
        actGoUpExecute(Sender);
    }
    else
    if(pLvf->IsDirSelected) {
        if(!pLvf->OnlyFileName.Pos("[..]")) {
            pLvf->Directory = pLvf->Directory + pLvf->OnlyFileName;
        }
    }
    else {
        ShellExecute(Application->Handle, NULL, pLvf->FileName.c_str(),
                   " ", pLvf->Directory.c_str(), SW_SHOW);
    }
    
    if(leftActive)
        pathLeft = pLvf->Directory;
    else
        pathRight = pLvf->Directory;
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::doLeftChange(TObject *Sender)
{
   editPathLeft->Text = doLeft->Directory.LowerCase();
   if(doLeft->Visible)
        lvfRight->Directory = doLeft->Directory;
   pathLeft = doLeft->Directory.LowerCase();
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::doRightChange(TObject *Sender)
{
   editPathRight->Text = doRight->Directory.LowerCase();
   if(doRight->Visible)
        lvfLeft->Directory = doRight->Directory;
   pathRight = doRight->Directory.LowerCase();
}
//---------------------------------------------------------------------------
// delete the selected file
void __fastcall TmainForm::fileDelete()
{
    bool res;
    selFilesToStrList();
    formProgress->Color = clrForm;
    formProgress->Caption = "Copying files";
    formProgress->progrBar->Max = pSelFilesPath->Count;
    formProgress->progrBar->Position = 0;
    formProgress->Show();
    for(int i = 0; i < pSelFilesPath->Count; ++i) {
        if(pSelFilesPath->Strings[i].Length()) {
            res = DeleteFile(pSelFilesPath->Strings[i]);
            if(!res)
                res = RemoveDir(pSelFilesPath->Strings[i]);
            if(!res) {
                if(chkDelDir) {
                    formConfirm->lbOperation->Caption = "The directory is not empty!\n" \
                        "Do you want to delete it with all its\nfiles and subdirectories?";
                    if(formConfirm->ShowModal() != mrOk) {
                        formProgress->Hide();
                        return;
                    }
                }
                res = delNotEmptyDir(pSelFilesPath->Strings[i]);
            }
            if(!res) {
                MessageBox(NULL, "Can't delete!", "Error",
                          MB_ICONINFORMATION);
                formProgress->Hide();
                return;
            }
        }
        formProgress->progrBar->Position = i;
    }
    formProgress->Hide();
    lvfLeft->UpdateData();
    lvfRight->UpdateData();
}
//---------------------------------------------------------------------------
// delete the directory which is not empty
bool __fastcall TmainForm::delNotEmptyDir(AnsiString path)
{
    TSearchRec srec;
    if(FindFirst((path + "\\*.*"), faAnyFile, srec) == 0) {
        if(srec.Attr & faDirectory) {
            if(srec.Name != "." && srec.Name != "..") {
                delNotEmptyDir(path + "\\" + srec.Name);
            }
        }
        else {
            DeleteFile(path + "\\" + srec.Name);
        }
        while(!FindNext(srec)) {
            if(srec.Attr & faDirectory) {
                if(srec.Name != "." && srec.Name != "..") {
                    delNotEmptyDir(path + "\\" + srec.Name);
                }
            }
            else {
                DeleteFile(path + "\\" + srec.Name);
            }
        }
        FindClose(srec);
    }
    return RemoveDir(path);
}
//---------------------------------------------------------------------------
// copy selected file
void __fastcall TmainForm::fileCopy()
{
    if(!leftAsTree && !rightAsTree) {
        TListViewFiles *pLvfs, *pLvfd;
        if(leftActive) {pLvfs = lvfLeft; pLvfd = lvfRight;}
        else {pLvfs = lvfRight; pLvfd = lvfLeft;}
        if(!pLvfs || !pLvfd) return;

        selFilesToStrList();
        formProgress->Color = clrForm;
        formProgress->Caption = "Copying files";
        formProgress->progrBar->Max = pSelFilesPath->Count;
        formProgress->progrBar->Position = 0;
        formProgress->Show();
        for(int i = 0; i < pSelFilesPath->Count; ++i) {
            if(pSelFilesPath->Strings[i].Length()) {
                BOOL res = CopyFile(pSelFilesPath->Strings[i].c_str(),
                             (pLvfd->Directory + pSelFilesName->Strings[i]).c_str(), TRUE);
                if(!res) {
                    if(pLvfs->isDirectory(pSelFilesPath->Strings[i])) {
                        dirCopy(pSelFilesPath->Strings[i].c_str(),
                            (pLvfd->Directory + pSelFilesName->Strings[i]).c_str());
                    }
                    else {
                        overwrt(pLvfs->Directory, pLvfd->Directory,
                                pSelFilesName->Strings[i]);
                    }
                }
                mr = 0;
            }
            formProgress->progrBar->Position = i;
        }
        //pLvfs->UpdateData();
        pLvfd->UpdateData();
        formProgress->Hide();
    }
}
//---------------------------------------------------------------------------
// copy directory
void __fastcall TmainForm::dirCopy(AnsiString spath, AnsiString dpath)
{
    TSearchRec srec;
    CreateDir(dpath);
    if(FindFirst((spath + "\\*.*"), faAnyFile, srec) == 0) {
        if(srec.Attr & faDirectory) {
            if(srec.Name != "." && srec.Name != "..") {
                dirCopy(spath + "\\" + srec.Name, dpath + "\\" + srec.Name);
            }
        }
        else {
            if(!CopyFile((spath + "\\" + srec.Name).c_str(),
                (dpath + "\\" + srec.Name).c_str(), TRUE))
            {
                overwrt(spath, dpath, srec.Name);
            }
        }
        while(!FindNext(srec)) {
            if(srec.Attr & faDirectory) {
                if(srec.Name != "." && srec.Name != "..") {
                    dirCopy(spath + "\\" + srec.Name, dpath + "\\" + srec.Name);
                }
            }
            else {
                if(!CopyFile((spath + "\\" + srec.Name).c_str(),
                    (dpath + "\\" + srec.Name).c_str(), TRUE))
                {
                    overwrt(spath, dpath, srec.Name);
                }
            }
        }
        FindClose(srec);
    }
}
//---------------------------------------------------------------------------
// overwrite
void __fastcall TmainForm::overwrt(AnsiString spath, AnsiString dpath,
                                    AnsiString name)
{
    if(mr != mrYesToAll && mr != mrNoToAll) {
        formOverwrite->lbOvrwrt->Caption = "Overwrite the existing file\n" +
                name + "?";
        mr = formOverwrite->ShowModal();
    }
    if(mr == mrYes || mr == mrYesToAll) {
        if(!CopyFile((spath + "\\" + name).c_str(),
            (dpath + "\\" + name).c_str(), FALSE))
            ShowMessage("Can't copy the file " + name + "!");
    }
}
//---------------------------------------------------------------------------
// make a new directory
void __fastcall TmainForm::actMakeDirExecute(TObject *Sender)
{
   if((leftActive && leftAsTree)||(!leftActive && rightAsTree)) return;
   TListViewFiles* pLvf;
   if(leftActive) pLvf = lvfLeft;
   else pLvf = lvfRight;
   if(!pLvf) return;

   newNameDlg->labelNewName->Caption = "Enter a new directory name:";
   newNameDlg->Caption = "New directory";
   newNameDlg->editNewName->Text = "";
   if(newNameDlg->ShowModal() == mrOk) {
      AnsiString newName = "\\" + newNameDlg->editNewName->Text;
      bool res = CreateDir(pLvf->Directory + newName);
      if(!res)MessageBox(NULL, "Can't create a directory!", "Error",
                             MB_ICONSTOP);
      lvfLeft->UpdateData();
      lvfRight->UpdateData();
   }

}
//---------------------------------------------------------------------------
// move selected files
void __fastcall TmainForm::fileMove()
{
    if(!leftAsTree && !rightAsTree) {
        bool res;
        TListViewFiles *pLvfd;
        if(leftActive) {pLvfd = lvfRight;}
        else {pLvfd = lvfLeft;}
        selFilesToStrList();
        formProgress->Color = clrForm;
        formProgress->Caption = "Copying files";
        formProgress->progrBar->Max = pSelFilesPath->Count;
        formProgress->progrBar->Position = 0;
        formProgress->Show();
        for(int i = 0; i < pSelFilesPath->Count; ++i) {
            if(pSelFilesPath->Strings[i].Length()) {
                res = MoveFile(pSelFilesPath->Strings[i].c_str(),
                        (pLvfd->Directory + pSelFilesName->Strings[i]).c_str());
                if(!res) {
                    MessageBox(NULL, "Can't move the file!", "Error",
                            MB_ICONINFORMATION);
                }
            }
            formProgress->progrBar->Position = i;
        }
        formProgress->Hide();
        lvfLeft->UpdateData();
        lvfRight->UpdateData();
    }
}
//---------------------------------------------------------------------------
// open selected file with the editor
void __fastcall TmainForm::actEditFileExecute(TObject *Sender)
{
    if((leftActive && leftAsTree)||(!leftActive && rightAsTree)) return;
    TListViewFiles* pLvf;
    if(leftActive) pLvf = lvfLeft;
    else pLvf = lvfRight;
    if(!pLvf) return;

    if(!pLvf->FileName.Length()) {
        ShowMessage("You must select a file!");
        return;
    }
    if(pLvf->IsDirSelected)
    {
        ShowMessage("You must select a valid file!");
        return;
    }
    WinExec((pathEditor + pLvf->FileName).c_str(), SW_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actActivateLeftExecute(TObject *Sender)
{
    makeLeftActive(true);
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actActivateRightExecute(TObject *Sender)
{
    makeLeftActive(false);
}
//---------------------------------------------------------------------------
// show options dialog
void __fastcall TmainForm::miOptionsClick(TObject *Sender)
{
    formOptions->edtEditor->Color = clrBkg;
    formOptions->cbForm->Color = clrBkg;
    formOptions->cbBkg->Color = clrBkg;
    formOptions->Color = clrForm;
    
    formOptions->edtEditor->Text = pathEditor;
    if(chkDelDir)
        formOptions->checkDelDir->Checked = true;
    else formOptions->checkDelDir->Checked = false;
    if(chkDel)
        formOptions->checkDel->Checked = true;
    else formOptions->checkDel->Checked = false;
    if(chkCopy)
        formOptions->checkCopy->Checked = true;
    else formOptions->checkCopy->Checked = false; 
    if(chkMove)
        formOptions->checkMove->Checked = true;
    else formOptions->checkMove->Checked = false;

    if(!sysClrForm) {
        formOptions->rbCustFormColor->Checked = true;
        formOptions->cbForm->Visible = true;
        formOptions->cbForm->Selected = clrForm;
    }
    else {
        formOptions->rbSysFormColor->Checked = true;
        formOptions->cbForm->Visible = false;
    }
    if(!sysClrBkg) {
        formOptions->rbCustBkgColor->Checked = true;
        formOptions->cbBkg->Visible = true;
        formOptions->cbBkg->Selected = clrBkg;
    }
    else {
        formOptions->rbSysBkgColor->Checked = true;
        formOptions->cbBkg->Visible = false;
    }

    if(formOptions->ShowModal() == mrOk) {
        pathEditor = formOptions->edtEditor->Text;

        if(formOptions->checkDelDir->Checked) chkDelDir = true;
        else chkDelDir = false;
        if(formOptions->checkDel->Checked) chkDel = true;
        else chkDel = false;
        if(formOptions->checkCopy->Checked) chkCopy = true;
        else chkCopy = false;
        if(formOptions->checkMove->Checked) chkMove = true;
        else chkMove = false;

        if(formOptions->rbCustFormColor->Checked) sysClrForm = false;
        else sysClrForm = true;
        if(formOptions->rbCustBkgColor->Checked) sysClrBkg = false;
        else sysClrBkg = true;
        if(sysClrForm) clrForm = clBtnFace;
        else clrForm = formOptions->cbForm->Selected;
        if(sysClrBkg) clrBkg = clWindow;
        else clrBkg = formOptions->cbBkg->Selected;
        setColor();
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actFileCopyExecute(TObject *Sender)
{
    if((leftActive && lvfLeft->Selected == NULL) ||
        (!leftActive && lvfRight->Selected == NULL))
    {
        ShowMessage("You must select a file(s)!");
        return;
    }
    if(chkCopy) {
        formConfirm->lbOperation->Caption = "Copy selected file(s)?";
        if(formConfirm->ShowModal() == mrOk) {
            fileCopy();
        }
    }
    else {
        fileCopy();
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actFileDelExecute(TObject *Sender)
{
    if((leftActive && lvfLeft->Selected == NULL) ||
        (!leftActive && lvfRight->Selected == NULL))
    {
        ShowMessage("You must select a file(s)!");
        return;
    }
    if(chkDel) {
        formConfirm->lbOperation->Caption = "Are you sure you want to\ndelete selected file(s)?";
        if(formConfirm->ShowModal() == mrOk)
            fileDelete();
    }
    else {
        fileDelete();
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actFileMoveExecute(TObject *Sender)
{
    if((leftActive && lvfLeft->Selected == NULL) ||
        (!leftActive && lvfRight->Selected == NULL))
    {
        ShowMessage("You must select a file(s)!");
        return;
    }
    if(chkMove) {
        formConfirm->lbOperation->Caption = "Move selected file(s)?";
        if(formConfirm->ShowModal() == mrOk)
            fileMove();
    }
    else {
        fileMove();
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::lvfLeftChange(TObject *Sender, TListItem *Item,
      TItemChange Change)
{
    editPathLeft->Text = lvfLeft->Directory.LowerCase();
    pathLeft = lvfLeft->Directory.LowerCase();
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::lvfRightChange(TObject *Sender, TListItem *Item,
      TItemChange Change)
{
    editPathRight->Text = lvfRight->Directory.LowerCase();
    pathRight = lvfRight->Directory.LowerCase();
}
//---------------------------------------------------------------------------

void __fastcall TmainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    //save user options into configuration file
    int hFile;
    if(FileExists(confFileName))
        DeleteFile(confFileName);
    if((hFile = FileCreate(confFileName)) == -1) {
        MessageBox(NULL, "Unable to create the configuration file  ",
                    "Error", MB_ICONSTOP);
        return;
    }
    FileWrite(hFile, pathEditor.c_str(), pathEditor.Length() + 1);
    if(chkDelDir) FileWrite(hFile, "\nt\n", 3);
    else FileWrite(hFile, "\nf\n", 3);
    if(chkDel) FileWrite(hFile, "t\n", 2);
    else FileWrite(hFile, "f\n", 2);
    if(chkCopy) FileWrite(hFile, "t\n", 2);
    else FileWrite(hFile, "f\n", 2);
    if(chkMove) FileWrite(hFile, "t\n", 2);
    else FileWrite(hFile, "f\n", 2);

    FileWrite(hFile, pathLeft.c_str(), pathLeft.Length());
    FileWrite(hFile, "\n", 1);
    FileWrite(hFile, pathRight.c_str(), pathRight.Length());
    FileWrite(hFile, "\n", 1);

    if(sysClrForm) FileWrite(hFile, "s\n", 2);
    else FileWrite(hFile, "c\n", 2);
    if(sysClrBkg) FileWrite(hFile, "s\n", 2);
    else FileWrite(hFile, "c\n", 2);
    AnsiString color = AnsiString(clrForm);
    FileWrite(hFile, color.c_str(), color.Length());
    FileWrite(hFile, "\n", 1);
    color = AnsiString(clrBkg);
    FileWrite(hFile, color.c_str(), color.Length());
    FileWrite(hFile, "\n", 1);

    FileClose(hFile);
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::lvfMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    TListViewFiles* pLvf = (TListViewFiles*)Sender;
    if(pLvf == lvfLeft)
        makeLeftActive(true);
    else
        if(pLvf == lvfRight)
            makeLeftActive(false);
    if(Button == mbRight && pLvf->Selected != NULL) {
        pmFile->Popup(Left + pLvf->Left + X, Top + pLvf->Top + Y + 50);
    }
    else {
        if(Button == mbLeft && pLvf->Selected != NULL) {
            if(Shift.Contains(ssShift)) {
                if(Shift.Contains(ssCtrl))
                    dragMove = true;
                else
                    dragMove = false;
                pLvf->BeginDrag(false, 15);
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actFileRenameExecute(TObject *Sender)
{
    if((leftActive && leftAsTree)||(!leftActive && rightAsTree)) return;
    TListViewFiles* pLvf;
    if(leftActive) pLvf = lvfLeft;
    else pLvf = lvfRight;
    if(!pLvf) return;
    if(pLvf->Selected == NULL) {
        ShowMessage("You must select a file(s)!");
        return;
    }

    newNameDlg->labelNewName->Caption = "Enter a new file name:";
    newNameDlg->Caption = "Rename";
    newNameDlg->editNewName->Text = "";
    if(pLvf->FileName.Length()) {
        if(newNameDlg->ShowModal() == mrOk) {
            AnsiString newName = newNameDlg->editNewName->Text;
            bool res = RenameFile(pLvf->FileName, pLvf->Directory + newName);
            if(!res) {
                if(pLvf->IsDirSelected)
                {
                    res = MoveFile(pLvf->FileName.c_str(),
                                    (pLvf->Directory + newName).c_str());
                }
                if(!res) {
                    AnsiString mess = "File " + newName +
                                " already exists. Can't rename!";
                    MessageBox(NULL, mess.c_str(), "Error", MB_ICONINFORMATION);
                }
            }
            lvfLeft->UpdateData();
            lvfRight->UpdateData();
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::lvfDragOver(TObject *Sender,
      TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
    if(Sender != Source)
        Accept = Source->ClassNameIs("TListViewFiles");
    else
        Accept = false;
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::lvfDragDrop(TObject *Sender,
      TObject *Source, int X, int Y)
{
    if(dragMove)
        fileMove();
    else
        fileCopy();
}
//---------------------------------------------------------------------------
// show properties of the file
void __fastcall TmainForm::actShowPropExecute(TObject *Sender)
{
    if((leftActive && leftAsTree)||(!leftActive && rightAsTree)) return;
    TListViewFiles* pLvf;
    if(leftActive) pLvf = lvfLeft;
    else pLvf = lvfRight;
    if(!pLvf) return;
    if(pLvf->Selected == NULL) {
        ShowMessage("You must select a file!");
        return;
    }

    formProp->lblName->Caption = pLvf->OnlyFileName;
    formProp->lblDir->Caption = pLvf->Directory;

    unsigned short attrs = FileGetAttr(pLvf->FileName);
    formProp->checkReadOnly->Checked = attrs & faReadOnly;
    formProp->checkArchive->Checked = attrs & faArchive;
    formProp->checkSystem->Checked = attrs & faSysFile;
    formProp->checkHidden->Checked = attrs & faHidden;

    TSearchRec srec;
    FindFirst(pLvf->FileName, faAnyFile, srec);
    if(!pLvf->IsDirSelected) {
        formProp->lblData->Caption =
                DateToStr(FileDateToDateTime(srec.Time));
        formProp->lblSize->Caption = AnsiString(srec.Size) + " bytes";
    }
    else {
        formProp->lblData->Caption =
                DateToStr(FileDateToDateTime(srec.Time));
        formProp->lblSize->Caption = "Directory";
    }

    unsigned short attrsNew;
    if(formProp->ShowModal() == mrOk) {
        //set the attributes of the current file
        attrsNew = attrs;
        if(formProp->checkReadOnly->Checked) attrsNew |= faReadOnly;
        else attrsNew &= ~faReadOnly;
        if(formProp->checkArchive->Checked) attrsNew |= faArchive;
        else attrsNew &= ~faArchive;
        if(formProp->checkSystem->Checked) attrsNew |= faSysFile;
        else attrsNew &= ~faSysFile;
        if(formProp->checkHidden->Checked) attrsNew |= faHidden;
        else attrsNew &= ~faHidden;
        
        if(attrsNew != attrs)
            FileSetAttr(pLvf->FileName, attrsNew);
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actExitExecute(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actRefreshExecute(TObject *Sender)
{
    if(leftActive) lvfLeft->UpdateData();
    else lvfRight->UpdateData();
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actRootExecute(TObject *Sender)
{
    if((leftActive && leftAsTree)||(!leftActive && rightAsTree)) return;
    TListViewFiles* pLvf;
    if(leftActive) pLvf = lvfLeft;
    else pLvf = lvfRight;
    if(!pLvf) return;

    pLvf->Directory = pLvf->Directory.SubString(1, 3);
    if(leftActive)
        pathLeft = pLvf->Directory;
    else
        pathRight = pLvf->Directory;
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actAboutExecute(TObject *Sender)
{
    aboutBoxDlg->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actShowHelpExecute(TObject *Sender)
{
    ShellExecute(Application->Handle, NULL, "Help.html",
                   " ", (GetCurrentDir()).c_str(), SW_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::lvfMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    TListViewFiles* pLvf;
    if(leftActive) pLvf = lvfLeft;
    else pLvf = lvfRight;
    if(!pLvf) return;

    TListItem* p = 0;
    if(Shift.Contains(ssLeft)) {
        p = pLvf->GetItemAt(X, Y);
        if(p) p->Selected = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::keyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch(Key) {
        case VK_F1: actShowHelpExecute(Sender); break;
        case VK_F3: actEditFileExecute(Sender); break;
        case VK_F4: actFileCopyExecute(Sender); break;
        case VK_F5: actFileRenameExecute(Sender); break;
        case VK_F6: actFileMoveExecute(Sender); break;
        case VK_F7: actMakeDirExecute(Sender); break;
        case VK_F8:
            case VK_DELETE: actFileDelExecute(Sender); break;
    }
}
//---------------------------------------------------------------------------
// place all selected files to the StringList
void __fastcall TmainForm::selFilesToStrList()
{
    TListViewFiles* pLvf;
    if(leftActive) pLvf = lvfLeft;
    else pLvf = lvfRight;
    if(!pLvf) return;

    TItemStates st = TItemStates() << isSelected;
    TListItem* p = pLvf->Selected;

    pSelFilesPath->Clear();
    pSelFilesName->Clear();
    pSelFilesPath->Add(pLvf->getPathOfItem(p));
    pSelFilesName->Add(pLvf->getNameOfItem(p));
    while((p = pLvf->GetNextItem(p, sdBelow, st)) != NULL) {
        pSelFilesPath->Add(pLvf->getPathOfItem(p));
        pSelFilesName->Add(pLvf->getNameOfItem(p));
    }
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::setColor()
{
    Color = clrForm;
    lvfLeft->Color = clrBkg;
    lvfRight->Color = clrBkg;
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_F1)
        actShowHelpExecute(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::FormShow(TObject *Sender)
{
    lvfLeft->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actSelAllExecute(TObject *Sender)
{
    TListViewFiles* pLvf;
    if(leftActive) pLvf = lvfLeft;
    else pLvf = lvfRight;
    if(!pLvf) return;
    pLvf->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::actGoUpExecute(TObject *Sender)
{
    TListViewFiles* pLvf;
    if(leftActive) pLvf = lvfLeft;
    else pLvf = lvfRight;
    if(!pLvf) return;
    if(pLvf->Directory.Length() <= 3) return;

    int i = pLvf->Directory.Length();
    if(pLvf->Directory[pLvf->Directory.Length()] == '\\') --i;
    for(; i > 0; --i)
        if(pLvf->Directory[i] == '\\')break;
    pLvf->Directory = pLvf->Directory.SubString(1, i);
}
//---------------------------------------------------------------------------


