//---------------------------------------------------------------------------
// (c)Alex A. Trubetskoy            alextr438@yandex.ru
//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <FileCtrl.hpp>
#include "cdiroutl.h"
#include <Grids.hpp>
#include <Outline.hpp>
#include <Menus.hpp>
#include <Tabs.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ActnList.hpp>
#include "ListViewFiles.h"
#include <ToolWin.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TmainForm : public TForm
{
__published:	// IDE-managed Components
    TCDirectoryOutline *doLeft;
    TCDirectoryOutline *doRight;
    TMainMenu *mainMenu;
    TMenuItem *miFile;
    TMenuItem *miExit;
    TMenuItem *miView;
    TMenuItem *miViewFiles;
    TMenuItem *miViewTree;
    TMenuItem *miHelpMain;
    TMenuItem *miAbout;
    TStatusBar *statusBar;
    TTabSet *tsLeft;
    TTabSet *tsRight;
    TSpeedButton *sbtnEdit;
    TSpeedButton *sbtnCopy;
    TSpeedButton *sbtnRename;
    TSpeedButton *sbtnMove;
    TSpeedButton *sbtnMkDir;
    TSpeedButton *sbtnDelete;
    TSpeedButton *sbtnExit;
    TMenuItem *miAction;
    TMenuItem *miRootDir;
    TActionList *actionList;
    TAction *actActivateLeft;
    TAction *actActivateRight;
    TEdit *editPathLeft;
    TEdit *editPathRight;
    TMenuItem *miConfig;
    TMenuItem *miOptions;
    TAction *actFileCopy;
    TAction *actFileDel;
    TAction *actFileMove;
    TListViewFiles *lvfLeft;
    TListViewFiles *lvfRight;
    TPopupMenu *pmFile;
    TMenuItem *pmiCopy;
    TMenuItem *pmiRename;
    TMenuItem *pmiMove;
    TMenuItem *pmiDel;
    TMenuItem *n1;
    TMenuItem *pmiProperties;
    TMenuItem *miProperties;
    TMenuItem *n2;
    TAction *actFileRename;
    TAction *actShowProp;
    TMenuItem *miRefresh;
    TToolBar *toolBar;
    TToolButton *tbtnRefresh;
    TImageList *imlToolBar;
    TToolButton *tbtnRoot;
    TToolButton *tbtnSep1;
    TToolButton *tbtnAbout;
    TToolButton *tbtnExit;
    TAction *actExit;
    TAction *actRefresh;
    TAction *actRoot;
    TAction *actAbout;
    TAction *actEditFile;
    TAction *actMakeDir;
    TMenuItem *miHelp;
    TAction *actShowHelp;
    TToolButton *tbtnSel;
    TToolButton *tbtnUp;
    TAction *actSelAll;
    TAction *actGoUp;
    TMenuItem *miToParDir;
    TMenuItem *miSelAll;
    TMenuItem *n3;
    void __fastcall miViewTreeClick(TObject *Sender);
    void __fastcall miViewFilesClick(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall tsLeftClick(TObject *Sender);
    void __fastcall tsRightClick(TObject *Sender);
    void __fastcall lvfDblClick(TObject *Sender);
    void __fastcall doLeftChange(TObject *Sender);
    void __fastcall doRightChange(TObject *Sender);
    void __fastcall actActivateLeftExecute(TObject *Sender);
    void __fastcall actActivateRightExecute(TObject *Sender);
    void __fastcall miOptionsClick(TObject *Sender);
    void __fastcall actFileCopyExecute(TObject *Sender);
    void __fastcall actFileDelExecute(TObject *Sender);
    void __fastcall actFileMoveExecute(TObject *Sender);
    void __fastcall lvfRightChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
    void __fastcall lvfLeftChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall lvfMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall actFileRenameExecute(TObject *Sender);
    void __fastcall lvfDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
    void __fastcall lvfDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);
    void __fastcall actShowPropExecute(TObject *Sender);
    void __fastcall actExitExecute(TObject *Sender);
    void __fastcall actRefreshExecute(TObject *Sender);
    void __fastcall actRootExecute(TObject *Sender);
    void __fastcall actAboutExecute(TObject *Sender);
    void __fastcall lvfMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
    void __fastcall keyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall actEditFileExecute(TObject *Sender);
    void __fastcall actMakeDirExecute(TObject *Sender);
    void __fastcall actShowHelpExecute(TObject *Sender);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall actSelAllExecute(TObject *Sender);
    void __fastcall actGoUpExecute(TObject *Sender);
    
private:	// User declarations
    bool leftAsTree, rightAsTree;
    bool leftActive;
    bool chkCopy, chkMove, chkDelDir, chkDel;
    bool dragMove;
    AnsiString pathLeft;
    AnsiString pathRight;
    AnsiString pathEditor;
    AnsiString confFileName;
    int mr;         //modal result for overwriting files
    TStringList* pSelFilesPath;       //path of selected files
    TStringList* pSelFilesName;       //name of selected files
    TColor clrForm, clrBkg;
    bool sysClrForm, sysClrBkg;

    void __fastcall fileDelete();
    void __fastcall fileCopy();
    void __fastcall fileMove();
    void __fastcall makeLeftActive(bool left);
    bool __fastcall delNotEmptyDir(AnsiString path);
    void __fastcall dirCopy(AnsiString spath, AnsiString dpath);
    void __fastcall overwrt(AnsiString spath, AnsiString dpath,
                            AnsiString name);
    void __fastcall selFilesToStrList();
    void __fastcall setColor();

public:		// User declarations
    __fastcall TmainForm(TComponent* Owner);
    __fastcall ~TmainForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TmainForm *mainForm;
//---------------------------------------------------------------------------
#endif
